<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;

class Ger02900ParametrosContabilizacaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getCtbprdtpoper($params) {
        $sql = "SELECT * FROM CTBPRDTPOPER WHERE CDPRODUTO = :CDPRODUTO AND IDENTRSAIDOP = :IDENTRSAIDOP AND CDTIPOOPER = :CDTIPOOPER AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getParamimpostofil($params) {
        $sql = "SELECT * FROM PARAMIMPOSTOFIL WHERE CDIMPOSTO = :CDIMPOSTO AND CDFILIAL = :CDFILIAL AND IDENTRSAIDOP = :IDENTRSAIDOP AND CDTIPOOPER = :CDTIPOOPER AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getCtbimptpoper($params) {
        $sql = "SELECT * FROM CTBIMPTPOPER WHERE CDIMPOSTO = :CDIMPOSTO AND IDENTRSAIDOP = :IDENTRSAIDOP AND CDTIPOOPER = :CDTIPOOPER AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getProdfili($params) {
        $sql = "SELECT * FROM PRODFILI WHERE CDFILIAL = :CDFILIAL AND CDPRODUTO = :CDPRODUTO AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getTipoctpagarfili($params) {
        $sql = "SELECT * FROM TIPOCTPAGARFILI WHERE CDFILIAL = :CDFILIAL AND CDTPCTPAGAR = :CDTPCTPAGAR AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetch();
    }

    public function getProdutosFiltrados($params) {
        $sql = "SELECT CDPRODUTO FROM PRODUTO WHERE CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }

    public function getFiliaisProdfiliFiltrados($params) {
        $sql = "SELECT DISTINCT CDFILIAL FROM PRODFILI WHERE NRORG = :NRORG AND CDFILIAL <> :CDFILIAL";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll(\PDO::FETCH_ASSOC);
    }

    public function getFiliaisTipoctpagarfiliFiltrados($params) {
        $sql = "SELECT DISTINCT CDFILIAL FROM FILIAL WHERE NRORG = :NRORG AND CDFILIAL <> :CDFILIAL";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll(\PDO::FETCH_ASSOC);
    }

    public function getTipoctpagarfiliFiltrados($params) {
        $sql = "SELECT CDTPCTPAGAR, CDCONTCTBL, CDFILIAL, NRORG FROM TIPOCTPAGARFILI WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG AND CDCONTCTBL IS NOT NULL";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll(\PDO::FETCH_ASSOC);
    }

    public function insertTipoctpagarfili($params) {
        $sql = "INSERT INTO TIPOCTPAGARFILI( CDTPCTPAGAR, NRORG, CDFILIAL, CDCONTCTBL, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO) VALUES ( :CDTPCTPAGAR, :NRORG, :CDFILIAL, :CDCONTCTBL, 'S', :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO )";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function updateTipoctpagarfili($params) {
        $sql = "UPDATE TIPOCTPAGARFILI SET CDCONTCTBL = :CDCONTCTBL, CDOPERULTATU = :CDOPERULTATU, NRORGULTATU = :NRORGULTATU, DTULTATU = :DTULTATU WHERE CDTPCTPAGAR = :CDTPCTPAGAR AND CDFILIAL = :CDFILIAL AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}
